trap "rm -f /tmp/$$.? ; exit 1" 0 1 2 3 15
echo "Automatic Psroff configuration tester.  V1.2 92/04/12"
type=
header=
troffnames="gtroff troff otroff cattroff catroff ditroff"
AS=undef
make=make
perl=
shell=/bin/sh
if [ -f /usr/apollo/bin/coffdump ]
then
    echo "You're an Apollo!"
    type=apollo
    shell=/bin/ksh
fi
if [ -f /ultrixboot ]
then
    case "`uname -a`" in
	*RISC*)
	    type=rult
	    echo "You're a RISC/Ultrix machine!"
	    ;;
    esac
    shell=/usr/bin/sh5
    make=s5make
fi
if [ -r /usr/lib/font/ftR ]
then
    header=/usr/lib/font/ftR
else
    echo "No /usr/lib/font/ftR file:  Can't check it for CAT troff HEADERSIZE."
    either=' either'
fi
cat > /tmp/$$.c <<\!
#include <stdio.h>
#include <a.out.h>
main() {
    printf("%d\n", sizeof(struct exec));
    exit(0);
}
!
cc -o /tmp/$$.a /tmp/$$.c > /dev/null 2>&1
if [ $? = 0 -a -f /tmp/$$.a ]
then
    t=`/tmp/$$.a`
    if [ $? = 0 ]
    then
	aoutheader=$t
    fi
fi
if [ -z "$aoutheader" ]
then
    echo "Can't compile a.out.h test: Can't check it for CAT troff HEADERSIZE$either."
    echo "(This test only works on V7 or BSDish machines (Ultrix, Sun etc.) anyways.)"
fi
if [ -n "$header" ]
then
    case "$type" in
	apollo)
	    set A `/usr/apollo/bin/coffdump -h $header | grep '\.data'`
	    HS=`echo "16 i $5 p q" | sed -e 's/0x0*//' | dc`
	    note=' /* Apollo cannot read own width tables - calc from coffdump */'
	    ;;
	rult)
	    AS=define
	    HS=0
	    note=' /* ignored on Risc/Ultrix */'
	    ;;
	*)
	    set A `ls -l $header`
	    case $5 in
		[0-9]*)
		    v=$5
		    ;;
		*)
		    v=$6
		    ;;
	    esac
	    HS=`expr $v - 224`
	    ;;
	esac
fi

case $aoutheader.$HS in
    [0-9]*.[0-9]*)
	if [ $aoutheader -lt $HS ]
	then
	    note=" /* though, might be $HS */"
	    HS=$aoutheader
	elif [ $HS -lt $aoutheader ]
	then
	    note=" /* remotely $aoutheader */"
	else
	    note=" /* a.out.h and .../ftR agree */"
	fi
	;;
    .)
	note=" Nope, can't figure out HEADERSIZE"
	;;
esac

paths=`echo $PATH | sed -e 's/:/ /g'`
for i in $paths
do
    for j in $troffnames
    do
	if [ -f $i/$j ]
	then
	    troffs="$troffs $i/$j"
	fi
    done
    if [ -f $i/lpr ]
    then
	lpr=1
    fi
    if [ -f $i/lp ]
    then
	lp=1
    fi
    if [ -f $i/hostname -a -z "$uuname" ]
    then
	uuname=hostname
    fi
    if [ -f $i/uuname -a -z "$uuname" ]
    then
	uuname='uuname -l'
    fi
    if [ -f $i/uname -a -z "$uuname" ]
    then
	uuname='uname -n'
    fi
    if [ -f $i/perl -a -z "$perl" ]
    then
	perl=$i/perl
    fi
done
if [ -z "$perl" ]
then
    perl="Not found: Won't be able to use catconv or buildljfonts"
fi
if [ -z "$uuname" ]
then
    uuname='echo <your node name>'
fi

echo "***  Recommended defs.h settings: ***"
echo
echo "#define HEADERSIZE $HS$note"
echo "#$AS ASCIIWIDTHS"
echo '#define NODECMD	"'"$uuname"'"'
echo
echo "*** Recommended Makefile settings: ***"
echo
echo "MAKE = $make"
echo "SHELL = $shell"
echo "PERL = $perl"
echo
echo "*** psrofflib-related stuff: ***"
echo
if [ -n "$troffs" ]
then
    for i in $troffs
    do
	echo "In order to use $i as your troff, you need to set:"
	echo hello | $i > /dev/null 2>&1
	ditroffokay=$?
	echo hello | $i -t > /dev/null 2>&1
	cattroffokay=$?

	if [ $ditroffokay = 0 -a $cattroffokay != 0 ]
	then
	    echo "    troff=$i # ditroff: use -N option in t2arg"
	    ditroff=1
	    continue
	fi
	if [ $ditroffokay != 0 -a $cattroffokay = 0 ]
	then
	    echo "    troff=$i # is CAT troff"
	    cattroff=1
	    if echo hello | $i -F/usr/lib/font/ftXX -t > /dev/null 2>&1
	    then
		echo "    trofftype='-F%%FONTDIR%%/\$width/ftXX'"
	    elif echo hello | $i -T. -t > /dev/null 2>&1
	    then
		echo "    trofftype='-T\$width'"
		echo "    [ps: FONTDIR MUST be /usr/lib/font]"
	    else
		echo "    trofftype= # Neither -F nor -T seem to work"
	    fi
	    continue
	fi 
	echo "Can't tell what kind of troff $i is"
    done
else
    echo "Couldn't seem to find any versions of troff out there in your PATH"
    echo "   (And I looked for $troffnames)"
    notroff=1
fi
echo
if [ -n "$lpr" ]
then
    echo "You have Berkeley style 'lpr'.  The lparg entry will typically"
    echo "be something like lparg=| [F |] lpr -P\$ptr -#\$copies'"
fi
if [ -n "$lp" ]
then
    echo "You have System V style 'lp'.  The lparg entry will typically"
    echo "be something like lparg=| [F |] lp -n\$copies -d\$ptr'"
fi
if [ -n "$lp" -o -n "$lpr" ]
then
    echo "Where 'F' is an additional filter, such as psxlate for PostScript"
fi

if [ -z "$lp" -a -z "$lpr" ]
then
    echo "Can't find lp or lpr, so I can't make any suggestions on the lparg"
    echo "entry."
fi

echo
echo "*** Overall automatic configurator error report) ***"
if [ -z "$cattroff" -a -z "$ditroff" ]
then
    echo "- You con't have any kind of troff in your search path."
    echo "  Unless you can find one, you can't use psroff."
fi
if [ -n "$cattroff" -a -z "$HS" ]
then
    echo "- You have CAT troff, but I couldn't figure out your HEADERSIZE."
    echo "  You should probably ask for help."
fi
if [ -z "$perl" ]
then
    echo "- Couldn't find perl - just means you can't emulate ditroff in CAT troff"
fi
trap '' 0
exit 0
